#ifndef __ENEMY
#define __ENEMY
#include <stdlib.h>
#include "structs.h"
#include "dif_tables.h"
#define noattackcount 5
#define followattackcount 5
#define diagonalattackcount 6
#define lineattackcount 6
Type_enemy types_enemy[4];
Enemy enemys[16];
u8 count_enemys;
u8 curlevel=1;
i16 boss_health;
u8 boss_cur_shot_type;
u8 boss_shoot_delay;
u8 boss_cur_shoot_delay;
u8 noattack_m[]= {0,1,0,0,0};
u8 followattack_m[]= {0,0,1,1,1};
u8 diagonalattack_m[]= {0,0,1,0,0,1};
u8 lineattack_m[]= {1,0,1,0,1,1};
u16 noattack[]= {12,27,44,105,306};
u16 followattack[]= {9,21,70,137,108};
u16 diagonalattack[]= {6,24,50,73,56,271};
u16 lineattack[]= {15,18,53,76,88,326};
u8 gn_napr(i8 dx,i8 dy)
{
    if(dx==0&&dy>0) return 0;

    if(dx<0&&dy>0) return 1;

    if(dx<0&&dy==0) return 2;

    if(dx<0&&dy<0) return 3;

    if(dx==0&&dy<0) return 4;

    if(dx>0&&dy<0) return 5;

    if(dx>0&&dy==0) return 6;

    if(dx>0&&dy>0) return 7;

    return 128;
}
void gen_types_enemy(i16 points)
{
    /*
    	 
    	0   .  0
    	1   .  40
    	2    .  30

    	
    	0  .  0
    	1    .  20
    	2   .  30
    	3   .  30

    	 
    	 1
    	  15  
    	 8

    	 
    	 10
    	  15  
    	 0

    	 
    	 1
    	  15  
    	 255

    	 
    	 120
    	  5  10 
    	 30

    	  
    	 1
    	  100  
    	 4

    	  
    	 10
    	  5  5 
    	 90

    	 
    	 10
    	  2  5 
    	 255
    */
    i16 a,c,d,curpoints;
    u8 b;

    for(a=0; a<4; a++) {
        types_enemy[a].health=10;
        types_enemy[a].power=5;
        types_enemy[a].shoot_delay=120;
        types_enemy[a].speed=1;
        types_enemy[a].move_delay=10;
        types_enemy[a].bullifetime=15;
        types_enemy[a].bulspeed=1;

        // 
        curpoints=points;

        if(curpoints>1024)curpoints=1024;

        b=rand16()%3;
        types_enemy[a].move_type=b;

        if(b==1)curpoints-=40;

        if(b==2)curpoints-=30;
        // 

        b=rand16()%32;
        b>>=3;

        if(b==4)b=0;

        types_enemy[a].shoot_type=b;

        if(types_enemy[a].move_type==0&&types_enemy[a].shoot_type==0)types_enemy[a].shoot_type++;

        if(b==1)curpoints-=20;

        if(b==2||b==3)curpoints-=30;

        //----------------------------------- 
        if(types_enemy[a].shoot_type==0) {
            c=1+curlevel+curdif;

            if(c>noattackcount)c=noattackcount;

            b=rand16()%c;

            types_enemy[a].picnum=noattack[b];
            types_enemy[a].numinmas=noattack_m[b];

        } else if(types_enemy[a].shoot_type==1) {
            c=1+curlevel+curdif;

            if(c>followattackcount)c=followattackcount;

            b=rand16()%c;
            types_enemy[a].picnum=followattack[b];
            types_enemy[a].numinmas=followattack_m[b];

        } else if(types_enemy[a].shoot_type==2) {
            c=1+curlevel+curdif;

            if(c>diagonalattackcount)c=diagonalattackcount;

            b=rand16()%c;
            types_enemy[a].picnum=diagonalattack[b];
            types_enemy[a].numinmas=diagonalattack_m[b];

        } else if(types_enemy[a].shoot_type==3) {
            c=1+curlevel+curdif;

            if(c>lineattackcount)c=lineattackcount;

            b=rand16()%c;
            types_enemy[a].picnum=lineattack[b];
            types_enemy[a].numinmas=lineattack_m[b];
        }

        //-----------------------------------
        c=0;

        while(c<8&&curpoints>0) {
            c++;
            d=rand16()%7;

            if(d==0) { //
                if(types_enemy[a].move_type!=0&&types_enemy[a].speed<8) {
                    if(curpoints>15) {
                        curpoints-=15;
                        types_enemy[a].speed++;
                        c=0;
                    }

                } else d++;

            } else if(d==1) { // 
                if(types_enemy[a].move_type!=0&&types_enemy[a].move_delay>0) {
                    if(curpoints>15) {
                        curpoints-=15;
                        types_enemy[a].move_delay--;
                        c=0;
                    }

                } else d++;

            } else if(d==2) { // 
                if(curpoints>10&&types_enemy[a].power<100) {
                    curpoints-=10;
                    types_enemy[a].power+=1;
                    c=0;

                } else d++;

            } else if(d==3) { // 
                if(curpoints>=15&&types_enemy[a].shoot_delay>20) {
                    curpoints-=15;
                    types_enemy[a].shoot_delay-=20;
                    //types_enemy[a].shoot_delay=16;
                    c=0;

                } else d++;

            } else if(d==4) { //  
                if(curpoints>50&&types_enemy[a].bulspeed<4) {
                    curpoints-=50;
                    types_enemy[a].bulspeed++;
                    c=0;

                } else d++;

            } else if(d==5) { //  
                if(curpoints>5&&types_enemy[a].bullifetime<90) {
                    curpoints-=5;
                    types_enemy[a].bullifetime+=5;
                    c=0;
                }

            } else if(d==6) { //
                if(curpoints>2&&types_enemy[a].health<250) {
                    curpoints-=2;
                    types_enemy[a].health+=5;
                    c=0;
                }

                //else c=0;
            }

            if(curpoints<=5)c=64;
        }

        //types_enemy[a].shoot_delay=0;
    }


}
#endif